'''
Shuffle LZ Decompression
'''

import struct

def compress(s):
    '''
    Dummy compression
    '''
    ptr = 0
    outstr = ''
    inputsize = len(s)
    while ptr < inputsize:
        block = s[ptr:ptr+8]
        flag = (0xff00 >> len(block))&0xff
        outstr += (chr(flag)+block)
        ptr += len(block)
    return outstr
        

def decompress(s):
    '''
    Decompress a Shuffle LZ string
    '''
    flagcount = 0
    outstr = ''
    inputsize = len(s)
    ptr = 0
    outsize = 0
    while ptr < inputsize:
        # print 'ptr='+hex(ptr)+'/'+hex(inputsize)
        # print 'outstr='+hex(len(outstr))
        if flagcount == 0:
            # read a flag byte
            flag = ord(s[ptr]) & 0xff
            # print 'NEW'+hex(flag)
            ptr+=1
            flagcount = 8
        if ptr >= inputsize: break
        # now check flag stuff
        # print 'flag='+hex(flag)
        if flag & 0x80:
            # print 'cpy'
            # straight copy
            outstr += s[ptr]
            # print repr(s[ptr])
            ptr+=1
            outsize+=1
        else:
            # print 'ref'
            # a reference entry
            refword, = struct.unpack('<H',s[ptr:ptr+2])
            ptr+=2
            count = (refword & 0xf) + 2
            pos = (refword >> 4) + 1
            block = outstr[-pos:][0:count]
            block = block * (count / len(block) + 1)
            block = block[0:count]
            outstr+=block
            outsize += count
        # update flag
        flag = flag << 1
        flagcount -= 1
    # print hex(outsize)
    return outstr
